package Marvin;
import robocode.*;
import robocode.util.Utils;

import java.awt.*;

public class Rambo extends AdvancedRobot {
	long targetDetected = -100;
	final int targetPower = 300;
	final int ahead = 50;

	public void run() {
		// Set colors
		setRadarColor(Color.darkGray);
		setBodyColor(new Color(0.0f,0.1f, 0.0f) );
		setGunColor(Color.black);
		setBulletColor(Color.green);
		setScanColor(Color.green);
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
	}
	public void onStatus(StatusEvent e) {
		// Scan around if no Target detected
		if (targetDetected <= getTime() - 10)
			setTurnRadarLeft(360);
		else
			setAhead(ahead);
	}
	public void onScannedRobot(ScannedRobotEvent e) {
		targetDetected = getTime();		
		setTurnRadarRight(2 * Utils.normalRelativeAngleDegrees(getHeading() + e.getBearing() - getRadarHeading()));
		turnFire(e.getBearing(),e.getDistance());
	}
	
	private void turnFire(double bearing, double distance){
		setTurnRight(Utils.normalRelativeAngleDegrees(bearing));
		setTurnGunRight(Utils.normalRelativeAngleDegrees(getHeading() + bearing - getGunHeading()));		
		if (Math.abs(getGunTurnRemaining()) < 2){
			double power = Math.min(targetPower/distance,Rules.MAX_BULLET_POWER);
			if (power > Rules.MIN_BULLET_POWER)
				setFire(power);
		}
	}

	public void onHitRobot(HitRobotEvent e) {
		turnFire(e.getBearing(),30);
	}
}
