package Marvin;
import robocode.*;
import robocode.util.Utils;

import java.awt.*;

public class WallE extends AdvancedRobot {

	long targetDetected = -100;
	long lastTurn = -100;
	boolean forward = true;
	double currentDir;
	final int targetPower = 300;
	final int turnDist = 100;
	final int wallDist = 200;
	final int ahead = 50;

	public void run() {
		// Set colors
		setBodyColor(Color.orange);
		setGunColor(Color.black);
		setRadarColor(Color.orange);
		setBulletColor(Color.orange);
		setScanColor(Color.orange);
		setAdjustGunForRobotTurn(true);
		setAdjustRadarForGunTurn(true);
		currentDir = getHeading() % 90;
		turnLeft(currentDir);
	}

	public void onStatus(StatusEvent e) {
		// Scan around if no Target detected
		if (targetDetected <= getTime() - 10)
			setTurnRadarLeft(360);
		// Random Direction
		if ((int) (Math.random() * 1000) == 1)
			turnTurnTurn(null);
		// Neue Richtung finden
		boolean N = getY() + wallDist > getBattleFieldHeight(), E = getX()
				+ wallDist > getBattleFieldWidth(), S = getY() < wallDist, W = getX() < wallDist;
		if (((W && forward) || (E && !forward)) && !N)
			currentDir = 0;
		else if (((N && forward) || (S && !forward)) && !E)
			currentDir = 90;
		else if (((E && forward) || (W && !forward)) && !S)
			currentDir = 180;
		else if (((S && forward) || (N && !forward)) && !W)
			currentDir = 270;
		doTurn();
	}

	public void onHitRobot(HitRobotEvent e) {
		turnTurnTurn(e.getBearing());
	}

	private void doTurn() {
		double dir = Utils.normalRelativeAngleDegrees(getHeading() - currentDir
				- (forward ? 0 : 180));
		if (lastTurn < getTime() - 10 && (dir > 90 || dir < -90)) {
			lastTurn = getTime();
			forward = !forward;
			dir = Utils.normalRelativeAngleDegrees(dir + 180);
		}
		setAhead((forward ? 1 : -1) * ahead);
		setTurnLeft(dir);
	}

	private void turnTurnTurn(Double bearing) {
		if (bearing == null || (forward && Math.abs(bearing) <= 90)
				|| (!forward && Math.abs(bearing) > 90)) {
			currentDir += 180;
			doTurn();
		}
	}

	public void onScannedRobot(ScannedRobotEvent e) {
		targetDetected = getTime();
		if (e.getDistance() < turnDist)
			turnTurnTurn(e.getBearing());
		setTurnRadarRight(2 * Utils.normalRelativeAngleDegrees(getHeading()
				+ e.getBearing() - getRadarHeading()));
		setTurnGunRight(Utils.normalRelativeAngleDegrees(getHeading()
				+ e.getBearing() - getGunHeading()));
		if (Math.abs(getGunTurnRemaining()) < 2) {
			double power = Math.min(targetPower / e.getDistance(),
					Rules.MAX_BULLET_POWER);
			if (power > Rules.MIN_BULLET_POWER)
				setFire(power);
		}

	}
}
